
package org.soitoolkit.commons.logentry.schema.v1;

import javax.xml.bind.annotation.XmlRegistry;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the org.soitoolkit.commons.logentry.schema.v1 package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {


    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.soitoolkit.commons.logentry.schema.v1
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link LogRuntimeInfoType }
     * 
     */
    public LogRuntimeInfoType createLogRuntimeInfoType() {
        return new LogRuntimeInfoType();
    }

    /**
     * Create an instance of {@link LogMessageExceptionType }
     * 
     */
    public LogMessageExceptionType createLogMessageExceptionType() {
        return new LogMessageExceptionType();
    }

    /**
     * Create an instance of {@link LogEntryType.ExtraInfo }
     * 
     */
    public LogEntryType.ExtraInfo createLogEntryTypeExtraInfo() {
        return new LogEntryType.ExtraInfo();
    }

    /**
     * Create an instance of {@link LogMetadataInfoType }
     * 
     */
    public LogMetadataInfoType createLogMetadataInfoType() {
        return new LogMetadataInfoType();
    }

    /**
     * Create an instance of {@link LogEvent }
     * 
     */
    public LogEvent createLogEvent() {
        return new LogEvent();
    }

    /**
     * Create an instance of {@link LogMessageType }
     * 
     */
    public LogMessageType createLogMessageType() {
        return new LogMessageType();
    }

    /**
     * Create an instance of {@link LogEntryType }
     * 
     */
    public LogEntryType createLogEntryType() {
        return new LogEntryType();
    }

    /**
     * Create an instance of {@link LogRuntimeInfoType.BusinessContextId }
     * 
     */
    public LogRuntimeInfoType.BusinessContextId createLogRuntimeInfoTypeBusinessContextId() {
        return new LogRuntimeInfoType.BusinessContextId();
    }

}
