
package org.soitoolkit.commons.servicemodel.schema.v1;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the org.soitoolkit.commons.servicemodel.schema.v1 package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _ServiceModel_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "serviceModel");
    private final static QName _ContractTypeMessageFlow_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "messageFlow");
    private final static QName _ApplicationServerTypeSoftwareComponents_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "softwareComponents");
    private final static QName _SoftwareComponentTypeContract_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "contract");
    private final static QName _SoftwareComponentTypeService_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "service");
    private final static QName _ServiceTypeFaultMessage_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "faultMessage");
    private final static QName _ServiceTypeEndpoint_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "endpoint");
    private final static QName _ResourceManagerTypeEndpoints_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "endpoints");
    private final static QName _HostTypeResourceManagers_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "resourceManagers");
    private final static QName _HostTypeApplicationServers_QNAME = new QName("urn:org.soitoolkit.commons.servicemodel.schema:v1", "applicationServers");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.soitoolkit.commons.servicemodel.schema.v1
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link EndpointType }
     * 
     */
    public EndpointType createEndpointType() {
        return new EndpointType();
    }

    /**
     * Create an instance of {@link ContractType }
     * 
     */
    public ContractType createContractType() {
        return new ContractType();
    }

    /**
     * Create an instance of {@link ServiceModelType }
     * 
     */
    public ServiceModelType createServiceModelType() {
        return new ServiceModelType();
    }

    /**
     * Create an instance of {@link SoftwareComponentType }
     * 
     */
    public SoftwareComponentType createSoftwareComponentType() {
        return new SoftwareComponentType();
    }

    /**
     * Create an instance of {@link ApplicationServerType }
     * 
     */
    public ApplicationServerType createApplicationServerType() {
        return new ApplicationServerType();
    }

    /**
     * Create an instance of {@link MessageFlowType }
     * 
     */
    public MessageFlowType createMessageFlowType() {
        return new MessageFlowType();
    }

    /**
     * Create an instance of {@link DomainType }
     * 
     */
    public DomainType createDomainType() {
        return new DomainType();
    }

    /**
     * Create an instance of {@link ServiceType }
     * 
     */
    public ServiceType createServiceType() {
        return new ServiceType();
    }

    /**
     * Create an instance of {@link MessageTypeType }
     * 
     */
    public MessageTypeType createMessageTypeType() {
        return new MessageTypeType();
    }

    /**
     * Create an instance of {@link ResourceManagerType }
     * 
     */
    public ResourceManagerType createResourceManagerType() {
        return new ResourceManagerType();
    }

    /**
     * Create an instance of {@link HostType }
     * 
     */
    public HostType createHostType() {
        return new HostType();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ServiceModelType }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "serviceModel")
    public JAXBElement<ServiceModelType> createServiceModel(ServiceModelType value) {
        return new JAXBElement<ServiceModelType>(_ServiceModel_QNAME, ServiceModelType.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "messageFlow", scope = ContractType.class)
    @XmlIDREF
    public JAXBElement<Object> createContractTypeMessageFlow(Object value) {
        return new JAXBElement<Object>(_ContractTypeMessageFlow_QNAME, Object.class, ContractType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "softwareComponents", scope = ApplicationServerType.class)
    @XmlIDREF
    public JAXBElement<Object> createApplicationServerTypeSoftwareComponents(Object value) {
        return new JAXBElement<Object>(_ApplicationServerTypeSoftwareComponents_QNAME, Object.class, ApplicationServerType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "contract", scope = SoftwareComponentType.class)
    @XmlIDREF
    public JAXBElement<Object> createSoftwareComponentTypeContract(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeContract_QNAME, Object.class, SoftwareComponentType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "service", scope = SoftwareComponentType.class)
    @XmlIDREF
    public JAXBElement<Object> createSoftwareComponentTypeService(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeService_QNAME, Object.class, SoftwareComponentType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "contract", scope = MessageFlowType.class)
    @XmlIDREF
    public JAXBElement<Object> createMessageFlowTypeContract(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeContract_QNAME, Object.class, MessageFlowType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "faultMessage", scope = ServiceType.class)
    @XmlIDREF
    public JAXBElement<Object> createServiceTypeFaultMessage(Object value) {
        return new JAXBElement<Object>(_ServiceTypeFaultMessage_QNAME, Object.class, ServiceType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "contract", scope = ServiceType.class)
    @XmlIDREF
    public JAXBElement<Object> createServiceTypeContract(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeContract_QNAME, Object.class, ServiceType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "endpoint", scope = ServiceType.class)
    @XmlIDREF
    public JAXBElement<Object> createServiceTypeEndpoint(Object value) {
        return new JAXBElement<Object>(_ServiceTypeEndpoint_QNAME, Object.class, ServiceType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "service", scope = DomainType.class)
    @XmlIDREF
    public JAXBElement<Object> createDomainTypeService(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeService_QNAME, Object.class, DomainType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "endpoints", scope = ResourceManagerType.class)
    @XmlIDREF
    public JAXBElement<Object> createResourceManagerTypeEndpoints(Object value) {
        return new JAXBElement<Object>(_ResourceManagerTypeEndpoints_QNAME, Object.class, ResourceManagerType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "service", scope = MessageTypeType.class)
    @XmlIDREF
    public JAXBElement<Object> createMessageTypeTypeService(Object value) {
        return new JAXBElement<Object>(_SoftwareComponentTypeService_QNAME, Object.class, MessageTypeType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "resourceManagers", scope = HostType.class)
    @XmlIDREF
    public JAXBElement<Object> createHostTypeResourceManagers(Object value) {
        return new JAXBElement<Object>(_HostTypeResourceManagers_QNAME, Object.class, HostType.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Object }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "urn:org.soitoolkit.commons.servicemodel.schema:v1", name = "applicationServers", scope = HostType.class)
    @XmlIDREF
    public JAXBElement<Object> createHostTypeApplicationServers(Object value) {
        return new JAXBElement<Object>(_HostTypeApplicationServers_QNAME, Object.class, HostType.class, value);
    }

}
