
package org.soitoolkit.commons.servicemodel.schema.v1;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import org.w3c.dom.Element;


/**
 * <p>Java class for ServiceModelType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="ServiceModelType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="messageFlow" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}MessageFlowType" maxOccurs="unbounded"/>
 *         &lt;element name="domain" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}DomainType" maxOccurs="unbounded"/>
 *         &lt;element name="messageType" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}MessageTypeType" maxOccurs="unbounded"/>
 *         &lt;element name="service" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}ServiceType" maxOccurs="unbounded"/>
 *         &lt;element name="contract" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}ContractType" maxOccurs="unbounded"/>
 *         &lt;element name="softwareComponent" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}SoftwareComponentType" maxOccurs="unbounded"/>
 *         &lt;element name="endpoint" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}EndpointType" maxOccurs="unbounded"/>
 *         &lt;element name="resourceManager" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}ResourceManagerType" maxOccurs="unbounded"/>
 *         &lt;element name="applicationServer" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}ApplicationServerType" maxOccurs="unbounded"/>
 *         &lt;element name="host" type="{urn:org.soitoolkit.commons.servicemodel.schema:v1}HostType" maxOccurs="unbounded"/>
 *         &lt;any/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ServiceModelType", propOrder = {
    "messageFlow",
    "domain",
    "messageType",
    "service",
    "contract",
    "softwareComponent",
    "endpoint",
    "resourceManager",
    "applicationServer",
    "host",
    "any"
})
public class ServiceModelType {

    @XmlElement(required = true)
    protected List<MessageFlowType> messageFlow;
    @XmlElement(required = true)
    protected List<DomainType> domain;
    @XmlElement(required = true)
    protected List<MessageTypeType> messageType;
    @XmlElement(required = true)
    protected List<ServiceType> service;
    @XmlElement(required = true)
    protected List<ContractType> contract;
    @XmlElement(required = true)
    protected List<SoftwareComponentType> softwareComponent;
    @XmlElement(required = true)
    protected List<EndpointType> endpoint;
    @XmlElement(required = true)
    protected List<ResourceManagerType> resourceManager;
    @XmlElement(required = true)
    protected List<ApplicationServerType> applicationServer;
    @XmlElement(required = true)
    protected List<HostType> host;
    @XmlAnyElement(lax = true)
    protected List<Object> any;

    /**
     * Gets the value of the messageFlow property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the messageFlow property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMessageFlow().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link MessageFlowType }
     * 
     * 
     */
    public List<MessageFlowType> getMessageFlow() {
        if (messageFlow == null) {
            messageFlow = new ArrayList<MessageFlowType>();
        }
        return this.messageFlow;
    }

    /**
     * Gets the value of the domain property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the domain property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDomain().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link DomainType }
     * 
     * 
     */
    public List<DomainType> getDomain() {
        if (domain == null) {
            domain = new ArrayList<DomainType>();
        }
        return this.domain;
    }

    /**
     * Gets the value of the messageType property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the messageType property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMessageType().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link MessageTypeType }
     * 
     * 
     */
    public List<MessageTypeType> getMessageType() {
        if (messageType == null) {
            messageType = new ArrayList<MessageTypeType>();
        }
        return this.messageType;
    }

    /**
     * Gets the value of the service property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the service property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getService().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ServiceType }
     * 
     * 
     */
    public List<ServiceType> getService() {
        if (service == null) {
            service = new ArrayList<ServiceType>();
        }
        return this.service;
    }

    /**
     * Gets the value of the contract property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the contract property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getContract().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ContractType }
     * 
     * 
     */
    public List<ContractType> getContract() {
        if (contract == null) {
            contract = new ArrayList<ContractType>();
        }
        return this.contract;
    }

    /**
     * Gets the value of the softwareComponent property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the softwareComponent property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSoftwareComponent().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link SoftwareComponentType }
     * 
     * 
     */
    public List<SoftwareComponentType> getSoftwareComponent() {
        if (softwareComponent == null) {
            softwareComponent = new ArrayList<SoftwareComponentType>();
        }
        return this.softwareComponent;
    }

    /**
     * Gets the value of the endpoint property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the endpoint property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getEndpoint().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link EndpointType }
     * 
     * 
     */
    public List<EndpointType> getEndpoint() {
        if (endpoint == null) {
            endpoint = new ArrayList<EndpointType>();
        }
        return this.endpoint;
    }

    /**
     * Gets the value of the resourceManager property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the resourceManager property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getResourceManager().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ResourceManagerType }
     * 
     * 
     */
    public List<ResourceManagerType> getResourceManager() {
        if (resourceManager == null) {
            resourceManager = new ArrayList<ResourceManagerType>();
        }
        return this.resourceManager;
    }

    /**
     * Gets the value of the applicationServer property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the applicationServer property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getApplicationServer().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ApplicationServerType }
     * 
     * 
     */
    public List<ApplicationServerType> getApplicationServer() {
        if (applicationServer == null) {
            applicationServer = new ArrayList<ApplicationServerType>();
        }
        return this.applicationServer;
    }

    /**
     * Gets the value of the host property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the host property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getHost().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link HostType }
     * 
     * 
     */
    public List<HostType> getHost() {
        if (host == null) {
            host = new ArrayList<HostType>();
        }
        return this.host;
    }

    /**
     * Gets the value of the any property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the any property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAny().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Object }
     * {@link Element }
     * 
     * 
     */
    public List<Object> getAny() {
        if (any == null) {
            any = new ArrayList<Object>();
        }
        return this.any;
    }

}
